Redmine - Feature #35432

Git: View annotation prior to the change
2021-06-22 10:01 - Go MAEDA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: SCM Estimated time: 0.00 hour
Target version: 5.1.0

Resolution: Fixed

Description

The "Blame" view of GitHub and Gitlab has a feature called "View blame prior to this change". With the feature, you can easily jump

to an older change of the line.

| think it would be useful if Redmine also has the feature. Currently, it requires some manual steps to see older changes in the

"Annotate" view of Redmine.

[Z) twofa_controller.rb 3.31KB fE.

MAEDA Go committed 9 months ago

MAEDA Go committed 2 months ago

‘? Adds two factor authentication support (r...

‘ ‘? Update copyright year in source files to 2...

View blame prior to this
change

Related issues:

Related to Redmine - Feature #38526: Subversion support for "View annotation ...

New

Associated revisions

Revision 22215 - 2023-04-29 08:59 - Go MAEDA

Code cleanup of RepositoriesController#fannotate (#35432).

Revision 22216 - 2023-04-29 11:49 - Go MAEDA

Display color bars on the left side of “td.line-code’ instead of on the right side of “td.author’ in the annotate view (#35432).

Revision 22217 - 2023-04-30 06:00 - Go MAEDA

Add "View annotation prior to this change" button in the annotate view of Git (#35432).

Patch by Takenori TAKAKI.

Revision 22218 - 2023-04-30 06:13 - Go MAEDA
Update locales (#35432).

History

#1 - 2021-07-08 10:07 - Takenori TAKAKI
- File 35432.patch added
- File disp_link_to_prior.png added

| made a patch to display the link to prior revision.
The patch adds a link to "Annotate" view as follows

disp_link_to_prior.png

#2 - 2021-07-24 09:58 - Go MAEDA

- Target version set to Candidate for next major release

#3 - 2021-08-22 11:01 - Mischa The Evil

- Subject changed from View annotate prior to the change to Git: View annotate prior to the change

+1 This is a real handy feature when browsing (Git) repositories a lot. Given the usability of this change | wonder if this is something that could be
implemented (easily) for other SCMs (Hg, SVN, ...) too?!

#4 - 2021-10-15 03:40 - Go MAEDA

Mischa The Evil wrote:

Given the usability of this change | wonder if this is something that could be implemented (easily) for other SCMs (Hg, SVN, ...) too?!

This feature is easy to implement in the Git adapter because “git blame -p” outputs the previous commit for the line, as shown in the "previous" like of
the following sample.

However, “blame’ / “annotate’ subcommand of other SCMs such as subversion doesn't give the information of the previous change, so we have to
find another way to get the previous change.

Since there are so many Git users these days, | think it is a good idea only for Git as a first step.

c91a4391d34b9%bd97270d20£f04aeb40eeb4166al 1 1 1
author Jean-Philippe Lang
author-mail <jp_lang@yahoo.fr>
author-time 1476985764
author-tz +0000
committer Jean-Philippe Lang
committer-mail <jp_lang@yahoo.fr>
committer-time 1476985764
committer-tz +0000
summary Set https back.
previous 15460450bbe72a756015e16689bcafebabbll6db Gemfile
filename Gemfile

source 'https://rubygems.org'
9315039€0a95b0234b7736£359£c039550£45e08 2 2 1
author Jean-Philippe Lang
author-mail <jp_lang@yahoo.fr>
author-time 1329661846
author-tz +0000
committer Jean-Philippe Lang
committer-mail <jp_lang@yahoo.fr>
committer-time 1329661846
committer-tz +0000
summary Use Bundler for gem management (#5638).
filename Gemfile

#5 - 2022-07-03 04:46 - Go MAEDA

- Target version changed from Candidate for next major release to 5.1.0

Setting the target version to 5.1.0.

#6 - 2022-09-03 09:36 - Go MAEDA
- File 0001-Git-View-annotate-prior-to-the-change.patch added

Updated the patch for the current trunk r21799.

#7 - 2023-04-23 09:04 - Go MAEDA

- File 0001-Code-cleanup-of-RepositoriesController-annotate.patch added

2024-03-13 2/3


https://www.redmine.org/projects/redmine/repository/svn/revisions/21799

- File 0002-Git-View-annotate-prior-to-the-change.patch added

| have updated the patch not to hard-code Repository::Git constant in app/views/repositories/annotate.html.erb.

#8 - 2023-04-30 06:10 - Go MAEDA

- File clipboard-202304301308-zmip9.png added
- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch in r22217 with slight modifications. Thank you for your contribution.

The annotate view of a Git repository now has "View annotation prior to this change" buttons.
clipboard-202304301308-zmip9.png
#9 - 2023-05-06 17:19 - Robert Korulczyk
- File def17b5f.png added
Go MAEDA wrote in #note-4:
However, “blame’ / “annotate’ subcommand of other SCMs such as subversion doesn't give the information of the previous change, so we have

to find another way to get the previous change.

You don't really need to know revision of previous change for SVN. Since revisions in SVN are sequential numbers, you only need to decrease
number of revision of given change and show annotations for this version. For example to see annotations prior r22231 for this file

5859 tmaruyama irev => nil},
:method => :get) do %>
4613 tmaruyama <k= text_rield tag "rev', @rev, :size => 8 %>
% maeda <¥= submit_tag 1(:button_view), :name => nil %=
jplang <% end %>

333 jplang </div>

you need to show annotations for revision 22230:
https://www.redmine.org/projects/redmine/repository/svn/revisions/22230/annotate/trunk/app/views/repositories/revision.html.erb

#10 - 2023-05-07 04:03 - Go MAEDA

- Related to Feature #38526: Subversion support for "View annotation prior to this change" added

#11 - 2023-05-07 04:09 - Go MAEDA

Robert Korulczyk wrote in #note-9:

You don't really need to know revision of previous change for SVN. Since revisions in SVN are sequential numbers, you only need to decrease
number of revision of given change and show annotations for this version.

Thank you for your suggestion. | have opened #38526 to implement this feature for Subversion.

#12 - 2023-05-07 04:10 - Go MAEDA

- Subject changed from Git: View annotate prior to the change to Git: View annotation prior to the change

Files

gitlab-view-blame-prior-to-this-change.png 124 KB 2021-06-22 Go MAEDA
35432.patch 6.09 KB 2021-07-08 Takenori TAKAKI
disp_link_to_prior.png 231 KB 2021-07-08 Takenori TAKAKI
0001-Git-View-annotate-prior-to-the-change.patch 288 KB 2022-09-03 Go MAEDA
0001-Code-cleanup-of-RepositoriesController-annotate.patch 1.39 KB 2023-04-23 Go MAEDA
0002-Git-View-annotate-prior-to-the-change.patch 7.44 KB 2023-04-23 Go MAEDA
clipboard-202304301308-zmip9.png 122 KB 2023-04-30 Go MAEDA
def17b5f.png 18.3 KB 2023-05-06 Robert Korulczyk
